



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>玩转JavaScript OOP[1]&mdash;&mdash;复杂类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">玩转JavaScript OOP[1]&mdash;&mdash;复杂类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 03:17:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>概述</h1>
<p>在JavaScript中，我们可以使用函数、数组、对象，以及日期、正则等一些内置类型的实例，它们都是复杂类型的表现。从本质上讲，这些复杂类型都是Object类型。本篇将主要介绍三种Object类型的体现：函数、数组和对象。</p>
<h1>函数</h1>
<p>函数是JavaScript的一大重点，它非常的灵活。不像C#这种强类型语言，可以显式地声明"class"，JavaScript没有"class"的概念，但借助函数我们可以实现"class"的概念。类和对象是面向对象编程的基础，所以掌握函数是掌握JavaScript面向对象编程的前提。</p>
<h2>定义函数</h2>
<p>JavaScript的函数有两种定义方式：函数声明和表达式声明。</p>
<h3>方式1：函数声明</h3>
<pre class="prettyprint linenums">// 函数声明<br />
function sum(a,b){<br />
	return a + b;<br />
}

var result = sum(3,5); // 8;</pre>
<p><strong>函数声明</strong>：<code>function</code>关键字后面跟着函数名称，参数放在一对小括号中，函数内容放在大括号内。<br>这段代码中，<code>sum</code>是函数的名称，如果指定了return语句，则可以通过变量来接收。</p>
<h3>方式2：表达式声明</h3>
<pre class="prettyprint linenums">// 表达式声明<br />
var hello = function(){<br />
	console.log('Hello!');<br />
}<br />
hello();</pre>
<p><strong>表达式声明</strong>：<code>function</code>关键字后面没有函数名称，这种函数也被称作<strong>匿名函数</strong>，匿名函数通常会被一个变量引用。<br>这段代码中，<code>hello</code>不是函数的名称，它是一个指向匿名函数的指针变量。<br>函数可以没有return语句，这时JavaScript引擎会自动地返回一个undefined。</p>
<h3>两种方式的区别</h3>
<p>虽然这两种方式比较相似，但它们有一个较大的区别——<strong>声明的提升</strong>。<br>使用方式1声明的函数会被会被提升至函数所处上下文的顶部，使用方式2则不会。</p>
<p>下面这段代码在浏览器中是可以工作的，并且不会报错。</p>
<pre class="prettyprint linenums">var result = sum(3,5); // 8;

// JavaScript引擎将函数声明提升到顶部<br />
function sum(a,b){<br />
	return a + b;<br />
}
</pre>
<p>上面这段代码会被JavaScript引擎解释为下面这段代码。</p>
<pre class="prettyprint linenums">function sum(a,b){<br />
	return a + b;<br />
}

var result = sum(3,5); // 8;
</pre>
<p>使用表达式声明的函数不会被提升，下面这段代码会报错。</p>
<pre class="prettyprint linenums">// 会报错：hello is not a function<br />
hello();

var hello = function(){<br />
	consol.log('Hello!');<br />
}
</pre>
<p>函数声明使得JavaScript引擎提前获知了函数的名称，匿名函数由于没有名称，JavaScript引擎无法对它进行提升。</p>
<p><strong>小提示：无论使用哪种方式，应该先声明函数再使用，这样才不会出错。</strong></p>
<h2>函数的类型</h2>
<p>使用typeof查看函数的类型时，得到的结果是"function"。<br>在JavaScript中，函数是一种特殊的引用类型，所有非函数的引用类型使用typeof都会返回"object"。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071351793-14236933.png"></p>
<p>之前提到了JavaScript只有一种复杂类型（引用类型）——Object类型，函数既然是引用类型，那么怎么证明他是属于Object类型的呢？</p>
<h3>使用instanceof操作符</h3>
<p>虽然JavaScript没有类的概念，但是它有构造函数的概念，JavaScript是通过构造函数来创建对象实例的。<br>instanceof操作符可以用来判断某个构造函数的prototype属性所指向的對象是否存在于另外一个要检测对象的原型链上。<br>后面的文章会讲到prototype和原型链，如果你不理解这句话，则可以将这个操作符看成C#中的is操作符（判断对象是否为某个类的实例）。</p>
<p>下面这幅图揭示了sum函数是Function的实例，Function又是Object的实例，sum也是Object的实例。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071352590-396985398.png"><br>Function()和Object()是JavaScript内置的两个构造函数。</p>
<p>sum()函数同样可以通过Function()函数来实现：</p>
<pre class="prettyprint linenums">var sum = new Function('a','b', 'return a + b;');
</pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071353308-349362010.png"></p>
<p>Function()构造函数的前面几个参数都表示函数的参数，最后一个参数表示函数的内容。<br>不管是函数参数还是函数内容，都是用字符串表示的，JavaScript引擎在运行时才需要先解析这种方式声明的函数，才能确定其形式。<br>虽然Function()构造函数可用于创建函数，但不建议这么做，因为它会使代码难以理解和调试。</p>
<p>小提示：在JavaScript中，new后面接的肯定是一个构造函数，例如new Function()、new Object()。</p>
<h2>函数的本质是数据</h2>
<p><strong>函数本质上是数据</strong>，这是一个比较重要的概念。<br>函数可以用表达式声明，并将其赋给一个变量。<br>变量用于存储数据，变量要么存储基础类型的值，要么存储引用类型的地址。</p>
<p>下面这段代码，sum是一个变量，存储的却是函数指针。<br>同时，这个匿名函数被当成一般的值，并赋给了变量add。</p>
<pre class="prettyprint linenums">var sum = function (a, b) {<br />
	return a + b;<br />
};

var add = sum;<br />
add(6,4);	// 10
</pre>
<p>JavaScript的函数就是数据，但它们是一种特殊的数据：</p>
<ul><li>包含代码</p>
<li>这些代码可以被执行或被调用</li></ul>
<h1>对象</h1>
<p>使用基础类型时，我们只能一个变量存储一个值，如果要将多个值存储在一个变量中，可以使用对象。<br>JavaScript中的对象是动态的，对象中包含属性，属性以key-value形式存在。<br>由于JavaScript的灵活性，使得我们可以为在任意地方指定对象的属性，对象的属性也可以被指定为任意类型。</p>
<h2>创建对象</h2>
<p>在使用对象前，我们应该先创建对象。<br>对象有两种创建方式：使用<code>{}</code>或<code>Object()</code>构造函数。</p>
<pre class="prettyprint linenums">// 方式1：使用{}创建对象<br />
var person = {<br />
	name: 'keepfool',<br />
	job: 'developer',<br />
	say: function() {<br />
		return 'Hello! I am ' + this.name + ', I am a ' + this.job;<br />
	}<br />
};

// 方式2：使用Object()构造函数<br />
var player = new Object();<br />
player.name = 'Stephen Cury';<br />
player.age = 28;<br />
player.play = function() {<br />
	return 'I am ' + this.name + ', ' + this.age + ' years old, I play basketball very well!';<br />
}
</pre>
<p>这两种方式本质上没有什么区别，使用方式1声明对象时，JavaScript引擎背后做的工作和new Object()是一样的。<br>方式1相当于方式2的快捷方式，建议使用方式1来创建。</p>
<p>在对象初始化后，你可以在任意时间给对象追加新的属性。</p>
<pre class="prettyprint linenums">// 方式1：使用{}创建对象<br />
var person = {<br />
	name: 'keepfool',<br />
	job: 'developer',<br />
	say: function() {<br />
		return 'Hello! I am ' + this.name + ', I am a ' + this.job;<br />
	}<br />
};

// 追加新的属性<br />
person.weigh = '70kg';<br />
person.run = function() {<br />
	return 'I am running!';<br />
}</pre>
<p><strong>注意：</strong>person对象的say属性是一个函数，当函数作为对象的一个属性时，我们称之为“方法”。<br>对象的属性就是数据，JavaScript的属性可以是方法，方法本质上是函数，从这个层面又印证了“函数就是数据”的说法。<br>say方法中用到了this，this是一个指针，它指向person对象本身，this.name即person.name。</p>
<h3>访问属性</h3>
<p>访问对象属性的方式也有两种：使用<code><em>object.property</em></code>和<code><em>object['property']</em></code>。</p>
<p><code><em>object.property</em></code>方式：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071354340-962773126.png"></p>
<p><code><em>object['property']</em></code>方式：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071355386-265180518.png"></p>
<p><strong>注意：</strong>person的say属性和player的play属性都是方法，通过person.say和player.play得到的是方法的指针（函数的指针），使用()才是调用对象的方法。<br>由于数组也提供了<code>[]</code>方式访问元素，为了区分数组和对象，建议使用<code><em>object.property</em></code>方式访问属性。</p>
<h2>对象的类型</h2>
<p>使用typeof查看对象的类型，得到的结果都是"object"。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071356121-15257891.png"></p>
<p>使用instanceof检测是否为Object类型，得到的结果都是true。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071356949-609663246.png"></p>
<h1>数组</h1>
<p>在C#中，数组中的元素是同一个类型的，JavaScript则不然。<br>在JavaScript中，你可以在数组中存储任意类型的值，数组元素可以是数字、字符、日期、对象、数组等等。<br>这和C#中的ArrayList有些相似。</p>
<h2>创建数组</h2>
<p>在JavaScript中，创建数组有两种方式：</p>
<pre class="prettyprint linenums">// 方式1：使用[]创建数组<br />
var arr1 = [1,"Hello", true, {id : 1, name : "keepfool"}];

// 方式2：使用Array()构造函数创建数组<br />
var arr2 = new Array(1, "Hello", true, {id : 1, name : "keepfool"});
</pre>
<p>方式1和方式2本质上是一样的，在使用方式1声明数组时，JavaScript引擎做的事情和new Array()也是一样的。<br>方式1比方式2更加便捷直观一些，建议使用方式1。</p>
<h3>访问数组元素</h3>
<p>数组是一个有序的数据集合，通过<code>[]</code>索引器可以访问数组元素。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071357808-611928195.png"></p>
<h2>数组的类型</h2>
<p>使用typeof查看数组的类型时，得到的结果是"object"。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071358574-547675845.png"></p>
<h3>数组的检测</h3>
<p>如果你定义了多个变量，有些变量用于表示对象，有些变量用于表示数组。<br>将typeof操作符应用于对象或数组变量，得到的结果都是"object"。<br>我们怎么区别哪个变量是对象，哪个变量时数组呢？有两种方式可以鉴别。</p>
<p><strong>方式1：使用instanceof</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071359496-1717165690.png"></p>
<p><strong>方式2：使用isArray()方法</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071400449-130571055.png"></p>
<h3>数组是否为Object？</h3>
<p>instanceof操作符检测函数的类型是Object的，那么数组也可以用这种方式来检测。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/341820/201606/341820-20160606071401183-1071371776.png"></p>
<p>所以数组本质上也是Object类型的。</p>
<h1>复杂类型总结</h1>
<ul><li>函数、对象和数组都是Object类型的实例，使用Instanceof操作符可以检测它们</p>
<li>函数的本质是数据，function是Function的实例，Function又是Object的实例
<li>对象是由属性构成的，对象的属性可以是任意类型的
<li>数组是有序的数据集合，数组元素可以是任意类型的，Array是Object的实例</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv2opz9.html">EF Code First 主键对应多个外键</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p34kyq.html">Code Page   编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oope18.html">《JavaScript权威指南》学习笔记 第四天 数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17gjx9.html">kernel 校验和实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mym3gq.html">IOS--UIImageView的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvyed8.html">分布式存储ceph&mdash;&mdash;（1）部署ceph</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodew3q.html">&lbrack;PHP&rsqb; 简单多进程并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/90movvm8.html">TensorRT&amp;amp&semi;Sample&amp;amp&semi;Python&lbrack;network&lowbar;api&lowbar;pytorch&lowbar;mnist&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdzg1d9.html">pycharm pip安装包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzk319.html">LeetCode 81 - 搜索旋转排序数组 II - &lbrack;二分&plus;暴力&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0p1j9.html">day18</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpm3z8.html">windows server 2008 r2安装windows media player</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gp50eq.html">阿里云 docker连接总报超时 registry&period;cn-hangzhou&period;aliyuncs&period;com &lpar;Client&period;Timeout exceeded while awaiting headers</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4v109.html">Spark思维导图之内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxpkz8.html">YCSB之HBase性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2wk7pq.html">JS&lowbar;高阶函数（filter）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w6jzwq.html">Apollo 3 定时&sol;长轮询拉取配置的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwv53v9.html">AI，大数据，复杂系统 最精 40本大书单</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0l44q.html">hasura graphql-engine v1&period;0&period;0-alpha26  版本新功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/953dvle8.html">&lbrack;Swift实际操作&rsqb;七、常见概念-&lpar;1&rpar;&period;范围Range、ClosedRange和NSRange的使用实际操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qy1ldjq.html">ROS学习（二）&mdash;&mdash;  配置ROS环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93yl4g8.html">UVA  11168 Airport（凸包&plus;直线方程）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1p0yq.html">border-radius四个值的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdp1l7q.html">OpenCV2&period;4&period;13&plus;VS2013开发环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwjpyl8.html">模拟CSS3 多组位移运动属性的框架封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7z1je9.html">oracle（sql）基础篇系列（四）&amp;mdash&semi;&amp;mdash&semi;数字字典、索引、序列、三范式</a>
			</li>
						<li><a href="https://www.batexi.com/a/495014e8.html">通用js函数集锦&amp;lt&semi;来源于网络&amp;gt&semi; 【二】</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kpgn69.html">Java 程序员必须掌握的 Linux 命令（转：导师Jencks）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdp4xvq.html">【转】浅谈truncate的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1lgzq.html">【JBOSS】 JBOSS目录结构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
